<?php
/**
 * @package BlogCampFlyerClient
 * @subpackage lib
 */
class BlogCampFlyerEvent
{
  /**
   * Available attributes
   * 
   * @private
   * @var
   */
  var $_attributes = array(
    'name' =>             '',
    'date' =>             '',
    'place' =>            '',
    'address' =>          '',
    'facebookUrl' =>      '',
    'twitterUrl' =>       '',
    'blogAnnounceUrl' =>  '',
    'widgetHtml' =>       ''
  );

  /**
   * Event constructor
   * 
   * @author 
   * @return 
   */
  function BlogCampFlyerEvent()
  {
  }

  /**
   * Generic getter
   * 
   * @author oncletom
   * @return string
   * @param string $attribute
   * @param string $alt_value[optional]
   */
  function get($attribute, $alt_value = '')
  {
    if (isset($this->_attributes[$attribute]))
    {
      return $this->_attributes[$attribute];
    }

    return $alt_value;
  }

  /**
   * Checks if the event is valid or not
   * 
   * For now we check only the data validity
   * 
   * @author oncletom
   * @return Boolean
   */
  function isValid()
  {
    return strtotime($this->_attributes['date']) <= time() ? false : true;
  }

  /**
   * Generic setter
   * 
   * @author oncletom
   * @return null
   * @param string $attribute
   * @param string $value
   */
  function set($attribute, $value)
  {
    if (isset($this->_attributes[$attribute]))
    {
      $this->_attributes[$attribute] = $value;
    }
  }

  /**
   * Displays a widget as HTML
   * 
   * @author oncletom
   * @return string
   */
  function show($return = true)
  {
    if ($return === true)
    {
      return $this->_attributes['widgetHtml'];
    }
    else
    {
      print $this->_attributes['widgetHtml'];
    }
  }
}